import { NativeModules, NativeEventEmitter } from 'react-native';

const inaiCryptoEvents = new NativeEventEmitter(NativeModules.RNInaiCrypto);

const removeSubscriptions = () => {
  inaiCryptoEvents.removeAllListeners('Inai::PAYMENT_SUCCESS');
  inaiCryptoEvents.removeAllListeners('Inai::PAYMENT_ERROR');
};

class InaiCrypto {

  static getCryptoPurchaseEstimates(purchaseDetails, successCallback, errorCallback) {

    return new Promise(function (resolve, reject) {
      inaiCryptoEvents.addListener('Inai::PAYMENT_SUCCESS', (data) => {
        let resolveFn = successCallback || resolve;
        resolveFn(data);
        removeSubscriptions()
      });

      inaiCryptoEvents.addListener('Inai::PAYMENT_ERROR', (data) => {
        let rejectFn = errorCallback || reject;
        rejectFn(data);
        removeSubscriptions()
      });

      NativeModules.RNInaiCrypto.getCryptoPurchaseEstimates(purchaseDetails);
    })
  }
}

export default InaiCrypto;
